%define name		groovy
%define version		1.0
%define beta		b10
%define release		0.%{beta}.1jpp
%define	section		free


Name:		%{name}
Summary:	Groovy scripting language
Url:		http://groovy.codehaus.org/
Version:	%{version}
Release:	%{release}
Epoch:		0
License:	BSD/Apache-style Software License
Group:		Development/Libraries/Java
Vendor:		JPackage Project
Distribution:	JPackage
BuildArch:	noarch
Source0:	groovy-1.0-beta-10-src.tar.gz
Source1:        pom-maven2jpp-depcat.xsl
Source2:        pom-maven2jpp-newdepmap.xsl
Source3:        pom-maven2jpp-mapdeps.xsl
Source4:        groovy-1.0-jpp-depmap.xml
Source5:	groovy.policy
Patch0:		groovy-1.0-jpp.patch
Patch1:		groovy-1.0-scripts.patch
Patch2:		groovy-1.0-conf.patch

BuildRequires:  jpackage-utils >= 0:1.5
BuildRequires:	ant >= 0:1.6
BuildRequires:	ant-junit >= 0:1.6
BuildRequires:	junit
BuildRequires:	maven
#
BuildRequires:	asm >= 0:1.5.3
BuildRequires:	axion
BuildRequires:	bsf
BuildRequires:	classworlds
BuildRequires:	jakarta-commons-cli
BuildRequires:	jakarta-commons-collections
BuildRequires:	jakarta-commons-logging
BuildRequires:	jakarta-commons-primitives
BuildRequires:	mockobjects
BuildRequires:	mx4j >= 0:2.0
BuildRequires:	nekohtml
BuildRequires:	qdox
BuildRequires:	radeox
BuildRequires:	regexp
BuildRequires:	servletapi4
BuildRequires:	xerces-j2
BuildRequires:	xml-commons-apis
#
Requires:	asm >= 0:1.5.3
Requires:	classworlds
Requires:	jakarta-commons-cli
BuildRoot:	%{_tmppath}/%{name}-%{version}-buildroot

%description
Groovy is a new agile dynamic language for the JVM 
combining lots of great features from languages like 
Python, Ruby and Smalltalk and making them available 
to the Java developers using a Java-like syntax.
Groovy is designed to help you get things done on the 
Java platform in a quicker, more concise and fun way - 
bringing the power of Python and Ruby inside the Java 
platform. 
Groovy can be used as an alternative compiler to javac 
to generate standard Java bytecode to be used by any 
Java project or it can be used dynamically as an 
alternative language such as for scripting Java objects, 
templating or writing unit test cases.


%package javadoc
Summary:	Javadoc for %{name}
Group:		Development/Documentation

%description javadoc
Javadoc for %{name}.

%prep
%setup -q -n groovy-1.0-beta-10
chmod -R go=u-w *
find . -name "*.jar" -exec rm -f {} \;
mkdir security
cp %{SOURCE5} security
mkdir xdocs

export DEPCAT=$(pwd)/groovy-1.0-depcat.new.xml
echo '<?xml version="1.0" standalone="yes"?>' > $DEPCAT
echo '<depset>' >> $DEPCAT
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    /usr/bin/saxon project.xml %{SOURCE1} >> $DEPCAT
    popd
done
echo >> $DEPCAT
echo '</depset>' >> $DEPCAT
/usr/bin/saxon $DEPCAT %{SOURCE2} > groovy-1.0-depmap.new.xml


%patch0 -b .sav
%patch1 -b .sav
%patch2 -b .sav

%build
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    cp project.xml project.xml.orig
    /usr/bin/saxon -o project.xml project.xml.orig %{SOURCE3} map=%{SOURCE4}
    popd
done

for p in $(find . -name project.properties); do
    echo >> $p
    echo maven.repo.remote=file:/usr/share/maven-1.0/repository >> $p
    echo maven.home.local=$(pwd)/.maven >> $p
done

mkdir -p .maven/repository/maven/jars
pushd .maven/repository/maven/jars
ln -sf $(build-classpath maven-jelly-tags) .
popd


mkdir -p .maven/repository/JPP/jars
pushd .maven/repository/JPP/jars
ln -sf $(build-classpath ant) .
ln -sf $(build-classpath ant-launcher) .
ln -sf $(build-classpath ant/ant-junit) ant-ant-junit.jar
ln -sf $(build-classpath asm/asm) asm-asm.jar
ln -sf $(build-classpath asm/asm-util) asm-asm-util.jar
ln -sf $(build-classpath asm/asm-analysis) asm-asm-analysis.jar
ln -sf $(build-classpath asm/asm-attrs) asm-asm-attrs.jar
ln -sf $(build-classpath axion) .
ln -sf $(build-classpath bsf) .
ln -sf $(build-classpath classworlds) .
ln -sf $(build-classpath commons-cli) .
ln -sf $(build-classpath commons-collections) .
ln -sf $(build-classpath commons-httpclient) .
ln -sf $(build-classpath commons-logging) .
ln -sf $(build-classpath commons-primitives) .
ln -sf $(build-classpath junit) .
ln -sf $(build-classpath mockobjects-core) .
ln -sf $(build-classpath mx4j/mx4j) mx4j-mx4j.jar
ln -sf $(build-classpath nekohtml) .
#ln -sf $(build-classpath openejb-loader) .
ln -sf $(build-classpath qdox) .
ln -sf $(build-classpath radeox) .
#ln -sf $(build-classpath radeox-oro) .
ln -sf $(build-classpath regexp) .
ln -sf $(build-classpath servletapi4) .
ln -sf $(build-classpath xerces-j2) .
ln -sf $(build-classpath xml-commons-apis) .
popd

maven	\
	-Dmaven.repo.remote=file:/usr/share/maven-1.0/repository \
	-Dmaven.home.local=$(pwd)/.maven \
	default javadoc:generate \

# delete DOS files
rm target/install/bin/*.bat

%install
find . -name "*.sav" -exec rm {} \;
# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -m 644 target/install/lib/%{name}-%{version}-beta-10.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/docs/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

# bin
install -d -m 755 $RPM_BUILD_ROOT%{_bindir}
install -m 755 target/install/bin/* $RPM_BUILD_ROOT%{_bindir}

# conf
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/conf
install -m 644 target/install/conf/* $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/conf

# lib
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/lib

%clean
rm -rf $RPM_BUILD_ROOT

%post
build-jar-repository %{_datadir}/%{name}-%{version}/lib \
asm/asm-analysis \
asm/asm-attrs \
asm/asm-util \
asm/asm \
classworlds \
commons-cli \
groovy


%preun
if [ "$1" = "0" ]; then
  rm %{_datadir}/%{name}-%{version}/lib/*.jar
fi

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%files
%defattr(-,root,root)
%doc LICENSE.txt
%{_javadir}/*
%attr(755, root, root) %{_bindir}/*
%{_datadir}/%{name}-%{version}

%files javadoc
%defattr(-,root,root)
%{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%changelog
* Tue Mar 15 2005 Ralph Apel <r.apel at r-apel.de> 0:1.0-0.b10.1jpp
- upgrade to 1.0-0.b10
- set runtime dependencies to asm, classworlds, commons-cli
- assure $HOME/.groovy/lib exists at startup
- activate user-specific library loading in *-classworlds.conf

* Sat Mar 12 2005 Ralph Apel <r.apel at r-apel.de> 0:1.0-0.b7.3jpp
- reduce runtime dependencies to asm, classworlds

* Tue Feb 01 2005 Ralph Apel <r.apel at r-apel.de> 0:1.0-0.b7.2jpp
- Process project.xml files with saxon
- Don't tamper with $HOME
- Don't use build-jar-repository; explicitly ln -sf $(build-classpath ...)

* Wed Dec 08 2004 Ralph Apel <r.apel at r-apel.de> 0:1.0-0.b7.1jpp
- First release
